function block = hdl_sci_sim(block, flag)
//zd&kc scicos-hdl 0.5 2007
   par_BT = block.opar; // truthtable position (port type and size
   nxu_type = par_BT(1);       // Sequential / continous block 
   nxu_trueTable = par_BT(2);  // Scilab Code
   nxu_inputNum = par_BT(3);   // number of inputs 
   nxu_outputNum = par_BT(4);  // number of outputs
   nxu_IONum = par_BT(5);      // 2^(number of inputs) = possible state
   nxu_name = par_BT(6);       // block name 
   
   
   //** Simulation state 
   Derivative = 0 ;
   OutUpdate  = 1 ;
   StateUpdate = 2 ;
   DelayTime = 3 ;
   Initialization = 4 ;
   Ending = 5;
   ReInit = 6;
   ImplicitB = 7;
   Mode = 9;
   
   select flag 
    
    case OutUpdate then 
            
            //  zi()   zo()  
            zi=0;
            zo=0;
            for i=1:nxu_inputNum             
              if block.inptr(i)(1) > 0.5 then
               zi(i) = 1;   //truth table: a9--a0 , computing function: u1--u10, that is the correspondence
              else
               zi(i) = 0;
              end
            end
   
            for i=1:nxu_outputNum               // scan all the states                         
                zo(i) = 0;
            end //** end of the loop 
   
           // pause;
            execstr(nxu_trueTable);
   
            for i=1:nxu_outputNum               // scan all the states  
              
              if zo(i)>0.5 then
                block.outptr(i)(1) =1 ;
              else
                block.outptr(i)(1) =0 ;
              end
            end //** end of the loop 
           // pause;
    case Initialization then 
          return ; //** nothing to init
    
    case ReInit then       
          return ; //** nothing to Re Init
          
   
    
    
    case Ending then 
          return ; //** nothing to End
   end 
   

endfunction
