//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Block depart =======================\\


function r=VerilogBlock(listNum,data,Link)
//    to=pout       from=pin
//    11.    1.    3.     1.
//    6.     1.    1.     1.
//    7.     1.    1.     2.
//    9.     1.    2.     1.
//    10.    1.    2.     2.
//    1.     1.    5.     1.
//    2.     1.    5.     2.
//    12.    1.    11.    1.
//    13.    1.    6.     1.

 
  block_opar=data.opar;        //function table  
   
  block_in=data.in;             //need [in"] data -> 

  block_out=data.out;           //need ["out"] data -> 

  if data.opar(1)==1 then          //combinational logic
     block_gui=data.opar(6);       //opar=list(1,['0','1';'00','11'],1,2,2,"LineDemux");
  elseif data.opar(1)==2           //ip block
     block_gui=data.opar(3);       //(2,"vhdl_file_name","block_name",2,2,["in1";"in2"],["out1";"out2"],VHDL,Verilog,SystemC) 10
  else                             //sequential logic
     block_gui=data.opar(2);       //opar=(3,"bm","01","0",2,2,["clk";"D"],["Q";"!Q"])
  end   
  //** log 2008 03 11
  //** modify block_gui (new opar like comment)   
  
  block_ipar=data.ipar;        //IO port define

  nin_num=length(block_in);     //the number of IN  ports 
  out_num=length(block_out);   //the number of out ports

  if block_gui=="SPLIT_f"
   
      out_num=out_num-1;       
  end
       
  new_name=block_gui+'_'+string(nin_num)+'_'+string(out_num);
  //message("++++")
  Link_Num=[];
  Link_Num=size(cmat);  //Link data

  block_pout=[]
  for i=1:Link_Num(1) 
    if Link(i,1) == listNum
       block_pout=[block_pout;i]
    end   
  end  
 //message("++ +++")
  block_pin=[];
  for j=1:Link_Num(1) 
    if Link(j,3) == listNum
       block_pin=[block_pin;j]
    end   
  end 

  //message(string(listNum)+"*"+block_gui+"*"new_name+"*"+string(nin_num)+"*"+string(out_num)+"*"+block_rpar(6)+"*"+string(block_pin(1))+"*"+string(Blk_pout(1))+string(block_ipar))
  r=list(listNum,block_gui,new_name,nin_num,out_num,block_opar,block_pin,block_pout,block_ipar)
//message(block_gui+"+")
endfunction
