//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Convert sys circuit=================\\

function NXU_data=Verilog_convert_Com(Block_data,path)  //功能衡  -->vhdl


  N_type=string(Block_data(1));       //the type of component  --> a constant
  N_port_data=Block_data(2); 
  N_inport_num=Block_data(3);         //the number of IN port  --> a variable
  N_outport_num=Block_data(4);        //the number of OUT port --> a variable
  N_port_state=Block_data(5);         //the number of states   --> a variable
  N_name=string(Block_data(6));       //name of the component

  New_name=N_name+ascii(95)+string(N_inport_num)+ascii(95)+string(N_outport_num); //new name
  
  in_for='in'+ascii(95);                                   // get the IN ports 

  for i=1:N_inport_num
    tmp_in(i,1)=i;
    in_name(i,1)=in_for+string(tmp_in(i));                 // port name:in_1,in_2....
  end

  indata=strcat(in_name,','); // IN port merge


  out_for='out'+ascii(95);                                 // get the OUT ports 

  for i=1:N_outport_num
    tmp_out(i,1)=i;
    out_name(i,1)=out_for+string(tmp_out(i));              // port name:out_1,out_2...
  end
             
  outdata=strcat(out_name,','); // OUT port merge

  moduleD='module'+ascii(32)+New_name+'('+indata+ascii(44)+outdata+')'+ascii(59);  //module data

  ninFinal='input'+ascii(32)+indata+ascii(59);     //in  put data
  outfinal='output'+ascii(32)+outdata+ascii(59);   //out put data
  
  if N_outport_num>1
     
     regfinal='reg ['+string(N_outport_num-1)+ascii(58)+string(0)+']'+ascii(32)+'outdata'+ascii(59); //reg data
     assignDa='assign'+ascii(32)+'{'+outdata+'}'+ascii(32)+'='+ascii(32)+'outdata'+ascii(59);  // assign data
  
  else
    
     regfinal='reg'+ascii(32)+'outdata'+ascii(59); //reg data
     assignDa='assign'+ascii(32)+outdata+ascii(32)+'='+ascii(32)+'outdata'+ascii(59);  // assign data
  end  
  
  

  orport=strcat(in_name,' or ');
  alwaysDa='always'+ascii(32)+ascii(64)+'('+orport+')';                  // always data
  beginDat='begin';


  if N_inport_num>1
     caseHead='case '+'({'+indata+'})';
  else
     caseHead='case '+'('+indata+')';
  end 

  for i=1:N_port_state             // get the case states
     Cnin_state=N_port_data(1,i);  // select states
     Cout_state=N_port_data(2,i);  // select states
     
     if (N_inport_num>1)&(N_outport_num>1)
     
         caseData(i)=string(N_inport_num)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outdata'+ascii(32)+'='+ascii(32)+string(N_outport_num)+ascii(39)+'b'+Cout_state+ascii(59);
    
     elseif (N_inport_num>1)&(N_outport_num<=1)
     
         caseData(i)=string(N_inport_num)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outdata'+ascii(32)+'='+ascii(32)+string(1)+ascii(39)+'b'+Cout_state+ascii(59);
   
     elseif (N_inport_num<=1)&(N_outport_num>1)
        
         caseData(i)=string(1)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outdata'+ascii(32)+'='+ascii(32)+string(N_outport_num)+ascii(39)+'b'+Cout_state+ascii(59);
    
     else
        
         caseData(i)=string(1)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outdata'+ascii(32)+'='+ascii(32)+string(1)+ascii(39)+'b'+Cout_state+ascii(59);
     
     end
     
  end
  rezult='';
  detmp='';
  
  if N_outport_num>1          //2007.3.4  kangcai made
     for k=1:N_outport_num
         detmp=detmp+'0';      
     end
     rezult=string(N_outport_num)+ascii(39)+'b'+detmp;     
  else
     rezult=string(1)+ascii(39)+'b0';  // make the default state =zz...
  end


  defaultD='default:'+ascii(32)+'outdata'+ascii(32)+'='+ascii(32)+rezult+ascii(59);

  endD(1)='endcase';  
  endD(2)='end';
  endD(3)='endmodule';
  
  //cosp(1)="// Copyright NXU AGL 2006.3";    2007.3.4  canceal this 
  cosp=ascii(32);
  ok=mgetl('SCI/macros/scicos-hdl/verilog/Copyrightverilog.txt');

  NXU_data=[cosp;moduleD;ninFinal;outfinal;regfinal;assignDa;alwaysDa;beginDat;caseHead;caseData;defaultD;endD;ok]

  file_name=path+New_name+'.v';  //New file name
  
  VerilogcomKC='';
  VerilogcomKC=spitline(NXU_data);  

  //write(file_name,VerilogcomKC);  //New file path
  
  mdelete(file_name);
  mputl(VerilogcomKC,file_name);
  mclose("all");

  
//endfunction

 


 
