//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~!  Scicos-HDL             !~*************\\
//***********~!       ZD--KC 2006-3     !~*************\\
//***********~!       NXU AGL           !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Sequential convert =================\\

function NXU_data=Verilog_convert_Seq(Block_data,path)  //时序逻辑元件 -->vhdl


  //opar =list(3,"block_name",'clk(01/10)','cr(1/0)',4,1,["clk";"D"],["q";"q!"],["INstate";"Qn";"Qn+1"],state_num); 10

  N_type=Block_data(1);          //the type of component  --> a constant
  N_port_data=Block_data(9);     //truth table
  N_inport_num=Block_data(5);    //the number of IN port  --> a variable
  N_outport_num=Block_data(6);   //the number of OUT port --> a variable
  N_port_state=Block_data(10);   //the number of states   --> a variable
  N_name=Block_data(2);          //name of the component
  N_clk=Block_data(3);           //clock of the bomponent
  //N_initial=Block_data(8);     //initial of circuit state not have this state
  N_cr=Block_data(4);            //clear output of circuit state
  //**log 2008 03 11 kc
  //** according the new opar data form, I correct the above codes


  verilog_temp='';
  
  New_name=N_name+ascii(95)+string(N_inport_num)+ascii(95)+string(N_outport_num); //new name
  
  //=====================================================================================  
   
  if N_cr=='no' //<1>
  
     in_for='in'+ascii(95);                                   // get the IN ports 
   
     for i=1:N_inport_num
       tmp_in(i,1)=i;
       in_name(i,1)=in_for+string(tmp_in(i));                 // port name:in_1,in_2....
     end

     indata=strcat(in_name,','); // IN port merge

     out_for='out'+ascii(95);                                 // get the OUT ports 

     for i=1:N_outport_num
       tmp_out(i,1)=i;
       out_name(i,1)=out_for+string(tmp_out(i));              // port name:out_1,out_2...
     end
             
     outdata=strcat(out_name,','); // OUT port merge

     moduleD='module'+ascii(32)+New_name+'('+indata+ascii(44)+outdata+')'+ascii(59);  //module data
          
     ninFinal='input'+ascii(32)+indata+ascii(59);     //in  put data
     outfinal='output'+ascii(32)+outdata+ascii(59);   //out put data
  
     if N_outport_num>1
     
        regfinal='reg ['+string(N_outport_num-1)+ascii(58)+string(0)+']'+ascii(32)+'outm'+ascii(59); //reg data
        assignDa='assign'+ascii(32)+'{'+outdata+'}'+ascii(32)+'='+ascii(32)+'outm'+ascii(59);  // assign data
  
     else
    
        regfinal='reg'+ascii(32)+'outm'+ascii(59); //reg data
        assignDa='assign'+ascii(32)+outdata+ascii(32)+'='+ascii(32)+'outm'+ascii(59);  // assign data
     end 
     clkD='posedge'+ascii(32)+'in_1'; 

     alwaysDa='always'+ascii(32)+ascii(64)+'('+clkD+')';                  // always data
     beginDat='begin';
       
     inNum=0;
     intemp='';
     inPP='';
     if N_inport_num>2
        for n=2:N_inport_num
            inNum=inNum+1;
            intemp(inNum)='in_'+string(n);
        end
        inPP=strcat(intemp,',');
     else
        inPP='in_2';
     end

     caseHead='case '+'({'+inPP+','+'outm'+'})';
     caseV=(N_inport_num-1)+N_outport_num;

     for i=1:N_port_state                 // get the case states
        Cnin_state=N_port_data(1,i)+N_port_data(2,i);  // select states
        Cout_state=N_port_data(3,i);  // select states  2007.3.4  kangcai correct
     
        if (caseV>1)&(N_outport_num>1)
     
           caseData(i)=string(caseV)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+string(N_outport_num)+ascii(39)+'b'+Cout_state+ascii(59);
    
        elseif (caseV>1)&(N_outport_num<=1)
     
           caseData(i)=string(caseV)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+string(1)+ascii(39)+'b'+Cout_state+ascii(59);
   
        elseif (caseV<=1)&(N_outport_num>1)
        
           caseData(i)=string(1)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+string(N_outport_num)+ascii(39)+'b'+Cout_state+ascii(59);
    
        else
        
           caseData(i)=string(1)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+string(1)+ascii(39)+'b'+Cout_state+ascii(59);
     
       end
     
    end
    
    //2007.3.4  add this default ------------------------------
    
  defaultDAta='';   
  rezult='';
  detmp='';
  
  if N_outport_num>1          //2007.3.4  kangcai made
     for k=1:N_outport_num
         detmp=detmp+'0';      
     end
     rezult=string(N_outport_num)+ascii(39)+'b'+detmp;     
  else
     rezult=string(1)+ascii(39)+'b0';  // make the default state =zz...
  end
   
  defaultDAta='default:'+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+rezult+ascii(59); 
    
    //--------------------------------2007.3.4-------------------

    endD(1)='endcase';  
    endD(2)='end';
    endmudel='endmodule';
    //message("caseData="+caseData+defaultDAta)

   //cosp(1)="// Copyright NXU AGL 2006.3";    2007.3.4  canceal this 
   cosp=ascii(32);
   ok=mgetl('SCI/macros/scicos-hdl/verilog/Copyrightverilog.txt');

    verilog_temp=[cosp;moduleD;ninFinal;outfinal;regfinal;alwaysDa;beginDat;caseHead;caseData;defaultDAta;endD;assignDa;endmudel;ok]
 

           
  //=====================================================================================
  
  else   
  
     in_for='in'+ascii(95);                                   // get the IN ports 

     for i=1:N_inport_num
       tmp_in(i,1)=i;
       in_name(i,1)=in_for+string(tmp_in(i));                 // port name:in_1,in_2....
     end

     indata=strcat(in_name,','); // IN port merge

     out_for='out'+ascii(95);                                 // get the OUT ports 

     for i=1:N_outport_num
       tmp_out(i,1)=i;
       out_name(i,1)=out_for+string(tmp_out(i));              // port name:out_1,out_2...
     end
             
     outdata=strcat(out_name,','); // OUT port merge

     moduleD='module'+ascii(32)+New_name+'('+indata+ascii(44)+outdata+')'+ascii(59);  //module data
          
     ninFinal='input'+ascii(32)+indata+ascii(59);     //in  put data
     outfinal='output'+ascii(32)+outdata+ascii(59);   //out put data
  
     if N_outport_num>1
     
        regfinal='reg ['+string(N_outport_num-1)+ascii(58)+string(0)+']'+ascii(32)+'outm'+ascii(59); //reg data
        assignDa='assign'+ascii(32)+'{'+outdata+'}'+ascii(32)+'='+ascii(32)+'outm'+ascii(59);  // assign data
  
     else
    
        regfinal='reg'+ascii(32)+'outm'+ascii(59); //reg data
        assignDa='assign'+ascii(32)+outdata+ascii(32)+'='+ascii(32)+'outm'+ascii(59);  // assign data
     end 
     clkD='posedge'+ascii(32)+'in_1'; 

     alwaysDa='always'+ascii(32)+ascii(64)+'('+clkD+')';                  // always data
     beginDat='begin';
     
     outpp='';
     outmp='';
     if N_outport_num>1
        for m=1:N_outport_num
          outmp=string(0)+outpp;
        end
        outpp=string(N_outport_num)+ascii(39)+'b'+outmp+ascii(59);
     else
        outpp=string(1)+ascii(39)+'b0'+ascii(59);
     end
     
     clrD='';
     clrD(1)='if ('+'in_2)';
     clrD(2)='outm='+outpp;
     clrD(3)='else';
       
     inNum=0;
     intemp='';
     inPP='';
     if N_inport_num>2
        for n=3:N_inport_num
            inNum=inNum+1;
            intemp(inNum)='in_'+string(n);
        end
        inPP=strcat(intemp,',');
        caseHead='case '+'({'+inPP+','+'outm'+'})';
     else
        inPP='';
        caseHead='case '+'(outm)';
     end
     
     caseV=0;
     caseV=(N_inport_num-2)+N_outport_num;

     for i=1:N_port_state                 // get the case states
        Cnin_state=N_port_data(1,i)+N_port_data(2,i);  // select states
        Cout_state=N_port_data(3,i);  // select states
     
        if (caseV>1)&(N_outport_num>1)
     
           caseData(i)=string(caseV)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+string(N_outport_num)+ascii(39)+'b'+Cout_state+ascii(59);
    
        elseif (caseV>1)&(N_outport_num<=1)
     
           caseData(i)=string(caseV)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+string(1)+ascii(39)+'b'+Cout_state+ascii(59);
   
        elseif (caseV<=1)&(N_outport_num>1)
        
           caseData(i)=string(1)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+string(N_outport_num)+ascii(39)+'b'+Cout_state+ascii(59);
    
        else
        
           caseData(i)=string(1)+ascii(39)+'b'+Cnin_state+ascii(58)+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+string(1)+ascii(39)+'b'+Cout_state+ascii(59);
     
       end
     
    end
    
        //2007.3.4  add this default ------------------------------
    
    defaultDAta='';   
    rezult='';
    detmp='';
  
    if N_outport_num>1          //2007.3.4  kangcai made
       for k=1:N_outport_num
           detmp=detmp+'0';      
       end
       rezult=string(N_outport_num)+ascii(39)+'b'+detmp;     
    else
       rezult=string(1)+ascii(39)+'b0';  // make the default state =zz...
    end
   
    defaultDAta='default:'+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+rezult+ascii(59); 
    
    //--------------------------------2007.3.4-------------------
    
    //message("caseData="+caseData+defaultDAta)
    endD(1)='endcase';  
    endD(2)='end';
    endmudel='endmodule';

   //cosp(1)="// Copyright NXU AGL 2006.3";    2007.3.4  canceal this 
   cosp=ascii(32);
   ok=mgetl('SCI/macros/scicos-hdl/verilog/Copyrightverilog.txt');

    verilog_temp=[cosp;moduleD;ninFinal;outfinal;regfinal;alwaysDa;beginDat;clrD;caseHead;caseData;defaultDAta;endD;assignDa;endmudel;ok]
 

    


  end  //<1>


   
   
  NXU_data=verilog_temp;
  
  file_name=path+New_name+'.v';    //New file name
  
  VerilogSeqenKC='';
  VerilogSeqenKC=spitline(NXU_data);  

 // write(file_name,VerilogSeqenKC);       //WRITE file path
 
 mdelete(file_name);
 mputl(VerilogSeqenKC,file_name);
 mclose('all');

endfunction
