//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Convert sys circuit=================\\

function NXU_vhdl_data=Vhdl_convert_Com(Block_data,path)  //功能衡  -->vhdl


  N_type=string(Block_data(1));       //the type of component  --> a constant
  N_port_data=Block_data(2); 
  N_inport_num=Block_data(3);         //the number of IN port  --> a variable
  N_outport_num=Block_data(4);        //the number of OUT port --> a variable
  N_port_state=Block_data(5);         //the number of states   --> a variable
  N_name=string(Block_data(6));       //name of the component

  New_name=N_name+ascii(95)+string(N_inport_num)+ascii(95)+string(N_outport_num); //new name
 
  in_for='in'+ascii(95);                                   // get the IN ports of VHDL
  in_type=ascii(58)+ascii(32)+'in std_logic'+ascii(59);    // IN port type

  for i=1:N_inport_num
    tmp_in(i,1)=i;
    in_name(i,1)=in_for+string(tmp_in(i));                 // port name:in_1,in_2....
    in_data(i,1)=in_name(i)+in_type;                       // in_(i): in std_logic;
  end

  in_add=strcat(in_name,'&');    
  process_in=strcat(in_name,',');
  indata='indata'+ascii(32)+ascii(58)+ascii(61)+ascii(32)+in_add+ascii(59);  // IN port merge
  

  out_for='out'+ascii(95);                                 // get the OUT ports of VHDL
  out_type1=ascii(58)+ascii(32)+'out std_logic'+ascii(59); // OUT port type
  out_type2=ascii(58)+ascii(32)+'out std_logic'+ascii(41)+ascii(59);  //OUT port type

  for i=1:N_outport_num
    tmp_out(i,1)=i;
    out_name(i,1)=out_for+string(tmp_out(i));              // port name:out_1,out_2...
  
    if i<N_outport_num      
       out_data(i,1)=out_name(i)+out_type1;              // out_(i): out std_logic;
    else
       out_data(i,1)=out_name(i)+out_type2; 
    end    
 end

  //out_add=strcat(out_name,'&');               
  //outdata='outdata'+ascii(60)+ascii(61)+out_add+ascii(59); // OUT port merge

  for i=1:N_port_state                 // get the case states
     Cin_state(i,1)=N_port_data(1,i);  // select states
  end


  case_datakc='';
  kc_mm=1;

  
  for i=1:N_port_state                 // case state
     if N_inport_num<2
        case_datakc(kc_mm)='when'+ascii(32)+ascii(39)+Cin_state(i,1)+ascii(39)+ascii(32)+ascii(61)+ascii(62); 
        kc_mm=kc_mm+1;
     else
        case_datakc(kc_mm)='when'+ascii(32)+ascii(34)+Cin_state(i,1)+ascii(34)+ascii(32)+ascii(61)+ascii(62);
        kc_mm=kc_mm+1;
     end
     for k=1:N_outport_num
         outStmp=part(N_port_data(2,i),k);
         case_datakc(kc_mm)=out_name(k)+ascii(32)+'<='+ascii(32)+ascii(39)+outStmp+ascii(39)+ascii(59);   
         kc_mm=kc_mm+1;
     end  
  end
  case_outD=[];
  case_othersD='when'+ascii(32)+'others'+'=>';
  //message("cccc"+string(N_outport_num))
  if N_outport_num>1  //port number more than 1
      for j=1:N_outport_num
          case_outD(j)=out_name(j)+ascii(32)+'<='+ascii(32)+ascii(39)+'0'+ascii(39)+ascii(59);
      end
     // message("dddddd"+case_outD)
  else
       case_outD=out_name+ascii(32)+'<='+ascii(32)+ascii(39)+'0'+ascii(39)+ascii(59);
       //message("pppp"+case_outD)
  end
//message("indata=="+indata)
//message("case_datakc=="+case_datakc)
//message("case_othersD=="+case_othersD)
//message("out_name=="+out_name)
//message("case_outD=="+case_outD)
//indata;NXU_cs;case_datakc;case_othersD;case_out

  arch_name='architecture NXU_beh of'+ascii(32)+New_name+ascii(32)+'is'; //architecture name define

  in_vector=string(N_inport_num-1);     //in signal port vector                                     
  
  if N_inport_num-1>0
    //V_in_name='variable indata: std_logic_vector(0 to'+ascii(32)+in_vector+ascii(41)+ascii(59);    //signal define 
    V_in_name='variable indata: std_logic_vector('+in_vector+ascii(32)+'downto 0'+ascii(41)+ascii(59);    //signal define
  else    
    V_in_name='variable indata: std_logic'+ascii(59);
  end 

  //NXU_header(1)="--Copyright NXU AGL 2007.2"+ascii(59);             // VHDL data---header 
  NXU_header(1)=ascii(32);
  NXU_header(2)='library IEEE'+ascii(59);
  NXU_header(3)='use ieee.std_logic_1164.ALL'+ascii(59);
//  NXU_header(4)='use ieee.std_logic_arith.ALL'+ascii(59);//not support in ghdl
//  NXU_header(5)='use ieee.std_logic_unsigned.ALL'+ascii(59);

  NXU_entity(1)='entity'+ascii(32)+New_name+ascii(32)+'is';// VHDL data---entity
  NXU_entity(2)='port'+ascii(40);

  NXU_inport=in_data;                                      // VHDL inport

  NXU_outport=out_data;                                    // VHDL outport

  NXU_entity_end='end'+ascii(32)+New_name+ascii(59);       // VHDL end entity

  NXU_archi_name=arch_name;                                // VHDL architecture name
  
  NXU_begin='begin';

  NXU_process='p1: process('+process_in+')';                    // VHDL process


  // VHDL architecture begin

  NXU_cs='case indata is';
 
  NXU_end(1)='end case'+ascii(59);                      
  NXU_end(2)='end process p1'+ascii(59); // VHDL end
  NXU_end(3)='end NXU_beh'+ascii(59);

  authers=mgetl('SCI/macros/scicos-hdl/vhdl/Copyrightvhdl.txt');

  NXU_vhdl_data=[NXU_header;NXU_entity;NXU_inport;NXU_outport;NXU_entity_end;NXU_archi_name;NXU_begin;NXU_process;V_in_name;NXU_begin;indata;NXU_cs;case_datakc;case_othersD;case_outD;NXU_end;authers]

  file_name=path+New_name+'.vhd';  //New file name

  VHDLCOMLANKC='';
  VHDLCOMLANKC=spitline(NXU_vhdl_data);
  mdelete(file_name);
  //write(file_name,VHDLCOMLANKC);  //New file path
  mputl(VHDLCOMLANKC,file_name)

  mclose("all")
endfunction

 


 
