//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Time convert -->vhdl=================\\

function NXU_vhdl_data=Vhdl_convert_Seq(Block_data,path)  //时序逻辑元件 -->vhdl

  //opar =list(3,"block_name",'clk(01/10)','cr(1/0)',4,1,["clk";"D"],["q";"q!"],["INstate";"Qn";"Qn+1"],state_num); 10

  N_type=Block_data(1);          //the type of component  --> a constant
  N_port_data=Block_data(9);     //truth table
  N_inport_num=Block_data(5);    //the number of IN port  --> a variable
  N_outport_num=Block_data(6);   //the number of OUT port --> a variable
  N_port_state=Block_data(10);   //the number of states   --> a variable
  N_name=Block_data(2);          //name of the component
  N_clk=Block_data(3);           //clock of the bomponent
  //N_initial=Block_data(8);     //initial of circuit state not have this state
  N_cr=Block_data(4);            //clear output of circuit state
  //**log 2008 03 11 kc
  //** according the new opar data form, I correct the above codes

  vhdl_tempfile='';
  
  New_name=N_name+ascii(95)+string(N_inport_num)+ascii(95)+string(N_outport_num); //new name
  
  //======================================================================================
  
  //NXU_header(1)="--Copyright NXU AGL 2007.2"+ascii(59);             // VHDL data---header 
  NXU_header(1)=ascii(32);
  NXU_header(2)='library IEEE'+ascii(59);
  NXU_header(3)='use ieee.std_logic_1164.ALL'+ascii(59);
//  NXU_header(4)='use ieee.std_logic_arith.ALL'+ascii(59);//not support in ghdl
//  NXU_header(5)='use ieee.std_logic_unsigned.ALL'+ascii(59);

  NXU_entity(1)='entity'+ascii(32)+New_name+ascii(32)+'is';// VHDL data---entity
  NXU_entity(2)='port'+ascii(40);

  authers=mgetl('SCI/macros/scicos-hdl/vhdl/Copyrightvhdl.txt');
  
  //=====================================================================================

  
   
    if N_cr=='no' //<1>   in_1 is the clk
    
          //--input port define----------------------------------------------------------------------
          
          in_name=[];                 // port name:in_1,in_2....
          in_data=[];                 // in_(i): in std_logic;
          
          counterINport=0;            // in putport counter

          in_for='in'+ascii(95);                                   // get the IN ports of VHDL
          in_type=ascii(58)+ascii(32)+'in std_logic'+ascii(59);    // IN port type
          
          if N_inport_num>2

             for i=2:N_inport_num
                          
                 counterINport=counterINport+1;
              
                 in_name(counterINport)=in_for+string(i);                 // port name:in_1,in_2.... >2
                 in_data(counterINport)=in_name(counterINport)+in_type;               // in_(i): in std_logic;
             end
          else
                 in_name=in_for+string(2);                 
                 in_data=in_name+in_type;                       // clk and in_2
          end

          clk_pin=in_for+string(1);                  // in_1=clk
          clk_port=in_for+string(1)+in_type;
          
          
  
        //   in_add=strcat(in_name,'&');  
        //   if N_inport_num-1>1
         //     indata='indata'+ascii(60)+ascii(61)+in_add+ascii(59);  // IN port merge
        //   else
        //      indata='indata(0)'+ascii(60)+ascii(61)+in_add+ascii(59);  // IN port merge
        //   end
        
       //--output port define----------------------------------------------------------------------
       
           out_for='out'+ascii(95);                                 // get the OUT ports of VHDL
           out_type1=ascii(58)+ascii(32)+'out std_logic'+ascii(59); // OUT port type
           out_type2=ascii(58)+ascii(32)+'out std_logic'+ascii(41)+ascii(59);  //OUT port type
           
           out_name=[];
           out_data=[];

           for i=1:N_outport_num
               //tmp_out(i,1)=i;
               out_name(i,1)=out_for+string(i);              // port name:out_1,out_2...
  
               if i<N_outport_num      
                  out_data(i,1)=out_name(i)+out_type1;       // out_(i): out std_logic;
               else
                  out_data(i,1)=out_name(i)+out_type2; 
               end    
           end
      //-- signal indata: std_logic_vector(0 to 1)--define----------------------------------------------------------------------
      
           SingINandOUT=''; //signal data
           
           totalPortN=0;  //port total Number except CLk
                                 
           if N_inport_num>1
              totalPortN=N_inport_num+N_outport_num-2;
              //SingINandOUT="signal indata"+ascii(58)+ascii(32)+'std_logic_vector'+ascii(40)+string(0)+ascii(32)+"to"+ascii(32)+string(totalPortN)+ascii(41)+ascii(59);
              SingINandOUT="signal indata"+ascii(58)+ascii(32)+'std_logic_vector'+ascii(40)+string(totalPortN)+ascii(32)+"downto 0"+ascii(41)+ascii(59);

           else
              SingINandOUT=" "; //signal indata: std_logic;             
           end
   
       //-- variable outD: std_logic_vector(0 to 1);----------------------------------------------------------------------
                       
           if N_outport_num>2   
           
              varible_outData='variable outD: std_logic_vector('+string(N_outport_num-1)+ascii(32)+'downto'+ascii(41)+ascii(59); 
              //  varible_outData='variable outD: std_logic_vector'+ascii(40)+string(N_outport_num-1)+ascii(32)+'downto 0'+ascii(41)+ascii(59);
           else

              varible_outData='variable outD: std_logic'+ascii(59);

           end  
           
       //-- out_1 <= outD;----------------------------------------------------------------------  
       
           // out_add=strcat(out_name,'&'); 
           kct=''; 
           if N_outport_num>1
              for n=1:N_outport_num
                  kct(n)=out_name(n)+ascii(32)+'<='+ascii(32)+'outD('+string(outport_num-n)+')'+ascii(59);
              end
           else
              kct=out_name+ascii(32)+'<='+ascii(32)+'outD'+ascii(59);
           end      
       
       //-- indata<=in_1 & outD;----------------------------------------------------------------------
       
          midData='';
         // message(string(counterINport))
          if N_inport_num>2
             in_add=strcat(in_name,'&');             
             midData="indata"+ascii(32)+'<='+ascii(32)+in_add+'&'+"outD"+ascii(59);
          elseif  N_inport_num==2  
             midData="indata"+ascii(32)+'<='+ascii(32)+in_name+'&'+"outD"+ascii(59);
          else
             midData=" ";
          end    
                       
      //-- case data-------------------------------------------------------------------------------------
      
           for i=1:N_port_state                  // get the case states
               Cin_state(i,1)=N_port_data(1,i)+N_port_data(2,i);  // select states
               Cout_state(i,1)=N_port_data(3,i); // result states
           end
           
           Cin_N=length(Cin_state(i,1));
           Cout_N=length(Cout_state(i,1));           
           
           for i=1:N_port_state                 // case state
             if (Cin_N>=2)&(Cout_N>=2)
               case_data(i,1)='when'+ascii(32)+ascii(34)+Cin_state(i,1)+ascii(34)+ascii(32)+ascii(61)+ascii(62)+ascii(32)+'outD '+ascii(58)+ascii(61)+ascii(34)+Cout_state(i,1)+ascii(34)+ascii(59);
             elseif (Cin_N>=2)&(Cout_N<2)
               case_data(i,1)='when'+ascii(32)+ascii(34)+Cin_state(i,1)+ascii(34)+ascii(32)+ascii(61)+ascii(62)+ascii(32)+'outD '+ascii(58)+ascii(61)+ascii(39)+Cout_state(i,1)+ascii(39)+ascii(59);
             elseif (Cin_N<2)&(Cout_N>=2)
               case_data(i,1)='when'+ascii(32)+ascii(39)+Cin_state(i,1)+ascii(39)+ascii(32)+ascii(61)+ascii(62)+ascii(32)+'outD '+ascii(58)+ascii(61)+ascii(34)+Cout_state(i,1)+ascii(34)+ascii(59);
             else
              case_data(i,1)='when'+ascii(32)+ascii(39)+Cin_state(i,1)+ascii(39)+ascii(32)+ascii(61)+ascii(62)+ascii(32)+'outD '+ascii(58)+ascii(61)+ascii(39)+Cout_state(i,1)+ascii(39)+ascii(59);
             end
           end
           
         //-- clk -------------------------------------------------------------------------------------           
           if N_clk=='01'

              clk_state='if'+ascii(32)+clk_pin+ascii(39)+'event and '+clk_pin+'='+ascii(39)+string(1)+ascii(39)+ascii(32)+'then';

           else

              clk_state='if'+ascii(32)+clk_pin+ascii(39)+'event and '+clk_pin+'='+ascii(39)+string(0)+ascii(39)+ascii(32)+'then';

           end

           end_ifclk='end if'+ascii(59);          

        //--2007.3.4  kc  case others--------------------------------
         
         case_outD=[];
         case_othersD='when'+ascii(32)+'others'+'=>';
         detmp='';
  
         if N_outport_num>1          //2007.3.4  kangcai made
            for k=1:N_outport_num
                detmp=detmp+'0';      
            end
            case_outD='outD'+ascii(32)+':='+ascii(34)+detmp+ascii(34)+ascii(59);     
         else
            case_outD='outD'+ascii(32)+':='+ascii(39)+'0'+ascii(39)+ascii(59);
          // make the default state =0000000000.
         end
   
        // defaultDAta='default:'+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+rezult+ascii(59); 
  
        //when others=> 
        //  outD :="00000";
    
         //-- others -------------------------------------------------------------------------------------
           
           arch_name='architecture NXU_beh of'+ascii(32)+New_name+ascii(32)+'is'; //architecture name define=
           
           NXU_inport=in_data;                                      // VHDL inport

           NXU_CLK=clk_port;

           NXU_outport=out_data;                                    // VHDL outport

           NXU_entity_end='end'+ascii(32)+New_name+ascii(59);       // VHDL end entity

           NXU_archi_name=arch_name;                                // VHDL architecture name

           NXU_signal=SingINandOUT;                              // VHDL signal define          

           NXU_begin='begin';                                       // VHDL architecture begin

           NXU_insignal=midData;                                     // VHDL inport merge

           NXU_process(1)='p1: process'+ascii(40)+clk_pin+ascii(41)+' is';
              
           if N_inport_num==1
             NXU_case_header='case'+ascii(32)+'outD is';
           else
             NXU_case_header='case'+ascii(32)+'indata is';
           end

           NXU_case=case_data;                                      // VHDL case
           
           NXU_final=kct;
           
           NXU_end_case='end case'+ascii(59); 
           NXU_end(1)='end if'+ascii(59); // VHDL end
           NXU_end(2)='end process p1'+ascii(59);
           NXU_end(3)='end NXU_beh'+ascii(59);    
           
           vhdl_tempfile=[NXU_header;NXU_entity;NXU_CLK;NXU_inport;NXU_outport;NXU_entity_end;NXU_archi_name;NXU_signal;NXU_begin;NXU_process;varible_outData;NXU_begin;NXU_insignal;clk_state;NXU_case_header;NXU_case;case_othersD;case_outD;NXU_end_case;NXU_final;NXU_end;authers]
          // vhdl_tempfile=[NXU_header;NXU_entity;NXU_inport;NXU_CLK;NXU_outport;NXU_entity_end;NXU_archi_name;NXU_signal;NXU_begin;NXU_process;new_outData;NXU_begin;NXU_insignal;clk_state;NXU_case_header;NXU_case;case_othersD;case_outD;NXU_end_case;NXU_final;NXU_end;authers]
        
           //=====================================================================================
  
   else        

          //--input port define----------------------------------------------------------------------
          
          in_name=[];                 // port name:in_1,in_2....
          in_data=[];                 // in_(i): in std_logic;
          
          counterINport=0;            // in putport counter

          in_for='in'+ascii(95);                                   // get the IN ports of VHDL
          in_type=ascii(58)+ascii(32)+'in std_logic'+ascii(59);    // IN port type
          
          if N_inport_num>3

             for i=3:N_inport_num
                          
                 counterINport=counterINport+1;
                 in_name(counterINport)=in_for+string(i);                 // port name:in_1,in_2.... >2
                 in_data(counterINport)=in_name(counterINport)+in_type;               // in_(i): in std_logic;
             end
          else
                 in_name=in_for+string(3);                 
                 in_data=in_name+in_type;                       // clk and cr and in_3
          end

          clk_pin=in_for+string(1);                  // in_1=clk
          clk_port=in_for+string(1)+in_type;
          
          cr_pin=in_for+string(2);                  // cr_1=clk
          cr_port=in_for+string(2)+in_type;  
        
       //--output port define----------------------------------------------------------------------
       
           out_for='out'+ascii(95);                                 // get the OUT ports of VHDL
           out_type1=ascii(58)+ascii(32)+'out std_logic'+ascii(59); // OUT port type
           out_type2=ascii(58)+ascii(32)+'out std_logic'+ascii(41)+ascii(59);  //OUT port type
           
           out_name=[];
           out_data=[];

           for i=1:N_outport_num
               //tmp_out(i,1)=i;
               out_name(i,1)=out_for+string(i);              // port name:out_1,out_2...
  
               if i<N_outport_num      
                  out_data(i,1)=out_name(i)+out_type1;       // out_(i): out std_logic;
               else
                  out_data(i,1)=out_name(i)+out_type2; 
               end    
           end
           
      //-- signal indata: std_logic_vector(0 to 1)--define----------------------------------------------------------------------
      
           SingINandOUT=''; //signal data
           
           totalPortN=0;  //port total Number except CLk cr
                                 
           if N_inport_num>2
              totalPortN=N_inport_num+N_outport_num-3;
              //SingINandOUT="signal indata"+ascii(58)+ascii(32)+'std_logic_vector'+ascii(40)+string(0)+ascii(32)+"to"+ascii(32)+string(totalPortN)+ascii(41)+ascii(59);
              SingINandOUT="signal indata"+ascii(58)+ascii(32)+'std_logic_vector'+ascii(40)+string(totalPortN)+ascii(32)+"downto 0"+ascii(41)+ascii(59);

           else
              SingINandOUT=" "; //signal indata: std_logic;             
           end
   
       //-- variable outD: std_logic_vector(0 to 1);----------------------------------------------------------------------
                       
           if N_outport_num>2   
           
              varible_outData='variable outD: std_logic_vector('+string(N_outport_num-1)+ascii(32)+'downto 0'+ascii(41)+ascii(59); 
              //  varible_outData='variable outD: std_logic_vector'+ascii(40)+string(N_outport_num-1)+ascii(32)+'downto 0'+ascii(41)+ascii(59);
           else

              varible_outData='variable outD: std_logic'+ascii(59);

           end  
           
       //-- out_1 <= outD;----------------------------------------------------------------------  
                 
           kct=''; 
           if N_outport_num>1
              for n=1:N_outport_num
                  kct(n)=out_name(n)+ascii(32)+'<='+ascii(32)+'outD('+string(N_outport_num-n)+')'+ascii(59);
              end
           else
              kct=out_name+ascii(32)+'<='+ascii(32)+'outD'+ascii(59);
           end      
       
       //-- indata<=in_1 & outD;----------------------------------------------------------------------
       
          midData='';
         // message(string(counterINport))
          if N_inport_num>3
             in_add=strcat(in_name,'&');             
             midData="indata"+ascii(32)+'<='+ascii(32)+in_add+'&'+"outD"+ascii(59);
          elseif  N_inport_num==3  
             midData="indata"+ascii(32)+'<='+ascii(32)+in_name+'&'+"outD"+ascii(59);
          else
             midData=" ";
          end    
                       
      //-- case data-------------------------------------------------------------------------------------
              
         for i=1:N_port_state                  // get the case states
            Cin_state(i,1)=N_port_data(1,i)+N_port_data(2,i);  // select states
            Cout_state(i,1)=N_port_data(3,i); // result states
               
            Cin_N=length(Cin_state(i,1));
            Cout_N=length(Cout_state(i,1));
               
            if (Cin_N>=2)&(Cout_N>=2)
                  case_data(i,1)='when'+ascii(32)+ascii(34)+Cin_state(i,1)+ascii(34)+ascii(32)+ascii(61)+ascii(62)+ascii(32)+'outD '+ascii(58)+ascii(61)+ascii(34)+Cout_state(i,1)+ascii(34)+ascii(59);
            elseif (Cin_N>=2)&(Cout_N<2)
               case_data(i,1)='when'+ascii(32)+ascii(34)+Cin_state(i,1)+ascii(34)+ascii(32)+ascii(61)+ascii(62)+ascii(32)+'outD '+ascii(58)+ascii(61)+ascii(39)+Cout_state(i,1)+ascii(39)+ascii(59);
            elseif (Cin_N<2)&(Cout_N>=2)
               case_data(i,1)='when'+ascii(32)+ascii(39)+Cin_state(i,1)+ascii(39)+ascii(32)+ascii(61)+ascii(62)+ascii(32)+'outD '+ascii(58)+ascii(61)+ascii(34)+Cout_state(i,1)+ascii(34)+ascii(59);
            else
               case_data(i,1)='when'+ascii(32)+ascii(39)+Cin_state(i,1)+ascii(39)+ascii(32)+ascii(61)+ascii(62)+ascii(32)+'outD '+ascii(58)+ascii(61)+ascii(39)+Cout_state(i,1)+ascii(39)+ascii(59);
            end              
               
         end
           
         //-- clk -------------------------------------------------------------------------------------           
           if N_clk=='01'

              clk_state='if'+ascii(32)+clk_pin+ascii(39)+'event and '+clk_pin+'='+ascii(39)+string(1)+ascii(39)+ascii(32)+'then';

           else

              clk_state='if'+ascii(32)+clk_pin+ascii(39)+'event and '+clk_pin+'='+ascii(39)+string(0)+ascii(39)+ascii(32)+'then';

           end

           end_ifclk='end if'+ascii(59);       
           
         //-- cr  -------------------------------------------------------------------------------------  
         
           if N_cr=='cr1'
           
              clear_s='if'+ascii(32)+cr_pin+'='+ascii(39)+string(1)+ascii(39)+ascii(32)+'then';
          
           else
           
              clear_s='if'+ascii(32)+cr_pin+'='+ascii(39)+string(0)+ascii(39)+ascii(32)+'then';
              
           end  
           
           for m=1:N_outport_num  //cr work
              cr_work(m)=out_name(m)+ascii(32)+'<='+ascii(32)+ascii(39)+string(0)+ascii(39)+ascii(32)+ascii(59);
           end
 
           cr_else='else';           
           
           
           end_ifcr='end if'+ascii(59);           

        //--2007.3.4  kc  case others--------------------------------
         
         case_outD=[];
         case_othersD='when'+ascii(32)+'others'+'=>';
         detmp='';
  
         if N_outport_num>1          //2007.3.4  kangcai made
            for k=1:N_outport_num
                detmp=detmp+'0';      
            end
            case_outD='outD'+ascii(32)+':='+ascii(34)+detmp+ascii(34)+ascii(59);     
         else
            case_outD='outD'+ascii(32)+':='+ascii(39)+'0'+ascii(39)+ascii(59);
          // make the default state =0000000000.
         end
   
        // defaultDAta='default:'+ascii(32)+'outm'+ascii(32)+'='+ascii(32)+rezult+ascii(59); 
  
        //when others=> 
        //  outD :="00000";
           
         //-- others -------------------------------------------------------------------------------------

           arch_name='architecture NXU_beh of'+ascii(32)+New_name+ascii(32)+'is'; //architecture name define
           
           if N_inport_num-2>0          
               NXU_inport=in_data;                                      // VHDL inport
               NXU_signal_in=SingINandOUT; 
               NXU_insignal=midData;                                     // VHDL inport merge

           else
               NXU_inport='';
               NXU_signal_in='';   
               NXU_insignal='';                                     // VHDL inport merge

           end                  

           NXU_CLK=clk_port;
           
           NXU_CR=cr_port;

           NXU_outport=out_data;                                    // VHDL outport

           NXU_entity_end='end'+ascii(32)+New_name+ascii(59);       // VHDL end entity

           NXU_archi_name=arch_name;                                // VHDL architecture name

                                        
           NXU_signal_out=varible_outData;                            // VHDL signal define

           NXU_begin='begin';                                       // VHDL architecture begin


           NXU_process(1)='p1: process'+ascii(40)+clk_pin+','+cr_pin+ascii(41)+' is';

           if N_inport_num==2
             NXU_case_header='case'+ascii(32)+'outD is';
           else
             NXU_case_header='case'+ascii(32)+'indata is';
           end

           NXU_case=case_data;                                      // VHDL case

           NXU_case_end='end case'+ascii(59);                         
 
           NXU_end(1)='end if'+ascii(59);// VHDL end
           NXU_end(2)='end if'+ascii(59);
           NXU_end(3)='end process p1'+ascii(59);           
           NXU_end(4)='end NXU_beh'+ascii(59);  
           
           vhdl_tempfile=[NXU_header;NXU_entity;NXU_CLK;NXU_CR;NXU_inport;NXU_outport;NXU_entity_end;NXU_archi_name;NXU_signal_in;NXU_begin;NXU_process;NXU_signal_out;NXU_begin;NXU_insignal;clear_s;cr_work;cr_else;clk_state;NXU_case_header;NXU_case;case_othersD;case_outD;NXU_case_end;kct;NXU_end;authers]
           

end  //<1>  
   
  NXU_vhdl_data=vhdl_tempfile;
  
  file_name=path+New_name+'.vhd';  //New file name
  
  VHDLsqenLANKC='';
  VHDLsqenLANKC=spitline( NXU_vhdl_data);

  //write(file_name,VHDLsqenLANKC);       //WRITE file pathwfile
  
  mdelete(file_name);
  mputl(VHDLsqenLANKC,file_name);
  
  mclose('all');

  
  

endfunction
