//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================test bench -->vhdl===============\\


function testdata=testbench_vhdl(TBinport,TBoutport,TBfileName,TBfilePath,TBinData,TBoutData,IN_difineData,OUT_difineData,embin_data,embout_data)

  NXU_header(1)=ascii(32);           
  NXU_header(2)="library ieee"+ascii(59);
  NXU_header(3)='use IEEE.std_logic_1164.all'+ascii(59);
//  NXU_header(4)="use IEEE.std_logic_arith.all"+ascii(59);//not support in ghdl
//  NXU_header(5)="use IEEE.std_logic_unsigned.all" +ascii(59);
  
  //----------------------------------------------------------------------------------------
 
  TbName=TBfileName+'_tb';

  //---------------------------------------------------------------------------------------
 
  [Tb_inD,Tb_outD]=testIO_vhdl(TBinport,TBoutport,embin_data,embout_data);   //for the test file-->entity ports define
                  
                  //Tb_inD  test bench  input ports define
                  //Tb_outD test bench  output ports define
                  //TbData  test bench  component map data
  
  //----------------------------------------------------------------------------------------
 
  Tb_entity(1)='entity'+ascii(32)+TbName+ascii(32)+'is';

  Tb_entity(2)='port'+ascii(40);

  //----------------------------------------------------------------------------------------
 
  Tb_entity_end='end'+ascii(32)+TbName+ascii(59); 
  
  Tb_arch_name='architecture NXU_tb of'+ascii(32)+TbName+ascii(32)+'is'; 
  
  Tb_lmp(1)='component'+ascii(32)+TBfileName;
  
  Tb_lmp(2)='port(';
  
  // TBinData + TBoutData
  
  tb_lmpE='end component'+ascii(59);
  
  tb_be='begin';

  Tb_archi_end='end'+ascii(32)+'NXU_tb'+ascii(59);

  // test bench fixed KangCai 2007.3.11----------------------------------------------------------
  
  IN_symbolData=IN_difineData;
  OUT_symbolData=OUT_difineData;
  
  [Tb_signalIND,Tb_singnalOUD,TbData,tbsingalINd,tbsingalOTd]=tb_Vhdl_signal_Define(TBinport,TBoutport,TBfileName,IN_symbolData,OUT_symbolData,embin_data,embout_data);   //for the test file-->entity ports define
  
   //pause
  //message('Tb_inD='+Tb_inD)
  //message('Tb_outD='+Tb_outD)
  //message('TbData='+TbData)
  
  //----------------------------------------------------------------------------------------
  
  //kczd='--Powered by scicos-hdl 0.3 ** ZhangDong&KangCai 2006 NXU'; //symbol of victory
 // ok='--Copyright NXU AGL (2005-2006)';
  kczd=mgetl('SCI/macros/scicos-hdl/vhdl/Copyrightvhdl.txt'); //symbol of victory
  //----------------------------------------------------------------------------------------
 
  test_top='';
  test_top=[NXU_header;Tb_entity;Tb_inD;Tb_outD;Tb_entity_end;Tb_arch_name;Tb_lmp;TBinData;TBoutData;tb_lmpE;Tb_signalIND;Tb_singnalOUD;tb_be;tbsingalINd;TbData;tbsingalOTd;Tb_archi_end;kczd]

  //----------------------------------------------------------------------------------------

  TbInwave='tbInwave'+'.test';
  Inwave='--write the input wave data as the input data to test the * '+TBfileName+'.vhd'+' *';

  TboutWave='tboutWave'+'.test';
  OutWave='--save the test data of * '+TBfileName+'.vhd'+' *';
  
  VHDLTBkc='';
  VHDLTBkc=spitline(test_top);
  
  //write(TBfilePath+TbName+'.vhd',VHDLTBkc)
  mdelete(TBfilePath+TbName+'.vhd');
  
  mputl(VHDLTBkc,TBfilePath+TbName+'.vhd')
  
  //write(TBfilePath+TbInwave,Inwave)
  mdelete(TBfilePath+TbInwave);
  mputl(Inwave,TBfilePath+TbInwave)

  //write(TBfilePath+TboutWave,OutWave)
  mdelete(TBfilePath+TboutWave);
  mputl(OutWave,TBfilePath+TboutWave)

  mclose('all');
  testdata='-- test bench ok';
  
  endfunction

