//===================================================================\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~******************\\
//***********~! VHDL--EDA Model Builder !~*************\\
//***********~!     ZD--KC 2006-3       !~*************\\
//***********~!        NXU AGL          !~*************\\
//***********~! NXU: www.nxu.edu.cn ~ ^ !~*************\\
//***********~! AGL: 202.203.128.55  .  !~*************\\
//***********~!-------- WELCOME --------!~*************\\
//***************~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*****************\\
//===================================================================\\

//=================Main function -->vhdl===============\\


function kczd=vhdlCompiler(Cos_path,Vhdl_path)  //Analyse the.COS file:Block/link

//==========================================================================================
  
  fileName=scs_m.props.title(1);          //file name when running scicos, the file .cos, its scs_m can be load auto

//==========================================================================================

  if length(Vhdl_path)<4
      pathtmp=scs_m.props.title(2);          //vhdl file path
      
  else
      pathtmp=Vhdl_path;
  end

  filePath=pathtmp;
  
//===============================super block analyse============================================================

  //scs_m = scs_all_supper2block(scs_m); //select to use c_pass1 function 2007-10-26 modify in INRIA

//=========================start compiler======================================
  //nxu_embBLK=scs_m.objs;                //cos data

  //nxu_embBLK_num=length(nxu_embBLK);    //block and link num

  //nxu_emb_LINKC_N=0;                    //Link number
  //nxu_emb_BLOCKC_N=0;                   //block number

  inport=0;                             //The number of inports
  outport=0;                            //The number of outports
  com_number=0;                         //the number of blocks

  L_num=0;                              //the link  total number
  B_num=0;                              //the block tatal number

  nxu_emb_LINKA=list();      //the l_b list engaged in simulation

  B_Data=list();             //the function list of blocks
  L_Data=list();             //the relationship of all blocks

  embin_data=list();         //embin  list
  embout_data=list();        //embout list

  kczd_block=list();         //block  list

  final_data=list();         //our library info

  block_lmp=list();          //block map data

  filter_D=list();           //filter data
  
  nxu_emb_BLOCKA=list();     //the simulation blocks list (unused for future)

  tb_blklst=list();
  tb_order=0;

//=============================================================================================

//   for i=1:nxu_embBLK_num    //depart the data of block and link
//
//     nxu_b_Type=getfield(1,nxu_embBLK(i));
//        
//      if nxu_b_Type(1)=='Link'                           //Link depart
//         nxu_emb_LINKC_N=nxu_emb_LINKC_N+1;
//         L_Data(nxu_emb_LINKC_N)=vhdlLink(nxu_embBLK(i));
//      end 
//        
//      if nxu_b_Type(1)=='Block'                          //Block depart
//         nxu_emb_BLOCKC_N=nxu_emb_BLOCKC_N+1;
//         B_Data(nxu_emb_BLOCKC_N)=vhdlBlock(i,nxu_embBLK(i));
//        // message(B_Data(nxu_emb_BLOCKC_N)(2)) 
//      end
//      
//      
//      
//   end
//         L_num=nxu_emb_LINKC_N;            //link number
//         B_num=nxu_emb_BLOCKC_N;           //block number
////message(B_Data)


//==============================================================================================

[blklst,cmat,ccmat,cor,corinv,ok,scs_m,flgcdgen,freof]=c_pass1(scs_m,-1);  //** get the information of every block 

for i=1:lstsize(blklst)
  
   if blklst(i).sim(1)=="tbbsnxu" then
      global G_G;
      
      G_G_NEW =[];
      
      for ggnew=1:length(blklst(i).out)
        G_G_NEW(ggnew) = G_G(ggnew);
        //message('kcc')
        //pause
      end
      
      blklst(i).opar = G_G_NEW;
      blklst(i).sim(1)="hdlzk_testbench_sim";
      blklst(i).in =[];
      //message('??')
      //pause
        global G_G_debug ; // 0 NO other =debug
        if G_G_debug>0 then
           message("VhdlCompiler.SCI-tbbsnxu");
           pause;
        end
   end  
end


[blklst,cmat]=scicoshdl_format(blklst,cmat);  //deal with the split thing

//blklst=SplitUse_filter(blklst,cmat);

//** blklst --> block data
//** cmat   --> regular link, from-> to 
//** ccmat  --> event link, from-> to

//[Blk_Info_all,Link_info_all]=get_all_info(blklst,cmat)

IP_Blk_sim='';  //** IPcore computing function

for i=1:lstsize(blklst)    //  filter the entity blocks
    
   IP_Blk_sim=strindex(blklst(i).sim(1),"zkc_");  //get IP core information
    
   if blklst(i).sim(1)=="hdl_tb_sim" | blklst(i).sim(1)=="hdl_st_sim" | blklst(i).sim(1)=="scicoshdlport" | IP_Blk_sim(1)==1  then        
      kczd_block(lstsize(kczd_block)+1)=vhdlBlock(i,blklst(i),cmat)      
   end 
   //message(blklst(i).sim(1)+string(i))
   if blklst(i).sim(1)=="hdlzk_testbench_sim" then
      //message('&')
     // pause
      tb_blklst=list(i,blklst(i).opar,blklst(i).out,blklst(i).in);
      tb_order=i; 
      //message(string(tb_blklst(1))+'~'+string(tb_blklst(2))+'~'+string(tb_blklst(3))+'~'+string(tb_blklst(4))+'~')
      //message("VhdlCompiler.SCI-hdlzk_testbench_sim");
      //pause;
   end 

end  //end of lstsize(blklst)

Link_Num=[];

L_Data=vhdlLink(cmat);
L_num=lstsize(L_Data);            //link number
com_number=lstsize(kczd_block);           //block number

//================================================================================================

portCounter=0;

for scicoshdlPort=1:com_number 
  
    if (kczd_block(scicoshdlPort)(2)=='embin') | (kczd_block(scicoshdlPort)(2)=='embout') then
       portCounter=portCounter+1;
    end   
end  

if portCounter > 0 then // if in/out block is in the file
  com_mynum=0; //block counter
  //================================================================================================
  for i=1:com_number                          //components categories

        name_com=kczd_block(i)(2);
   
        if name_com=='embin'               //in port components :20070805kc yinchuan add ipar data for IO difine

            inport=inport+1;               //get the tatol number

            [IO_IN_difine_IPARdata(inport),embin_data(inport)]=Vhdl_in(kczd_block(i)); //ADD THE IPAR DATA: 20070805 YINCHUAN

         elseif name_com=='embout'          //out port components :20070805kc yinchuan add ipar data for IO difine

            outport=outport+1;              //get the tatol number

            [IO_OUT_difine_IPARdata(outport),embout_data(outport)]=Vhdl_out(kczd_block(i));  //ADD THE IPAR DATA: 20070805 YINCHUAN

         else                               //entity components

            com_mynum=com_mynum+1;          //get the tatol number :20070805 entity block no ipar data

            final_data(com_mynum)=block_vhdl(kczd_block(i));  //later we add one is the order in globle define

        end
  end 


//====================================================================================================================

  [filter_D,filter_num]=Vhdl_filter(final_data,com_mynum); //filter the same data


//====================================================================================================================
  
  Every_B=Vhdl_B_Admin(filter_D,filter_num,filePath); //block vhdl code generator administrator

                    //filter_D  : all the parameters of every blocks

                    //filter_num: tatol number of blocks in your model file 

                    //filePath  : form:"/root/Desktop/tmp/"-->where users save there files(path)

//==========================================================================================================================
 
  lmp=Vhdl_mapB(filter_D,filter_num)  //lmp_data ok
                 
//==========================================================================================================================

  [inData,outData]=Top_port(inport,outport,embin_data,embout_data);     //for the top file-->entity ports define

//==========================================================================================================================

  [signal_B,mapbl_data]=vhdl_BlockMap(final_data,com_mynum,cmat); //for the top file-->component map

//==========================================================================================================================

  mapbei_data=vhdl_InMap(embin_data,inport);            //top file-->IN&signal map

//==========================================================================================================================

  [signal_O,mapbeo_data]=vhdl_OutMap(embout_data,outport);//top file-->OUT&signal map

//==========================================================================================================================


//==========================================================================================================================

  fileinfoVh=forUsersVh(final_data,com_mynum);  //doc

//==========================================================================================================================
//message("uuuu") //good debug
//pause

  if lstsize(tb_blklst)==0
     testbenchP=testbench_vhdl(inport,outport,fileName,filePath,inData,outData,IO_IN_difine_IPARdata,IO_OUT_difine_IPARdata,embin_data,embout_data); //testbench --> vhdl 2007.3.11
  else
    //message('<<') 
    
    testb_data_kc=testb(fileName,filePath,inData,outData,tb_blklst,cmat,inport,embin_data,outport,embout_data);
    //message('>>')
  end
//message("pppppppp") //good debug
//pause
  //docfile=blockDocVhdl(filePath,fileName,filter_D,filter_num,fileinfoVh);

//==========================================================================================================================

//**************************~~~~~~~~~~~~~~~~~*********************************************************
//**************************~!VHDL TOP FILE!~*************************************
//**************************~!   NXU AGL   !~*************************************
//**************************~!ZD--KC 2006-3!~*************************************
//**************************~~~~~~~~~~~~~~~~~*********************************************************

//--------------------VHDL data-->header--------------------------------------------

  NXU_header(1)=ascii(32);
  NXU_header(2)='library IEEE'+ascii(59);
  NXU_header(3)='use ieee.std_logic_1164.ALL'+ascii(59);
//  NXU_header(4)='use ieee.std_logic_arith.ALL'+ascii(59); //not support in ghdl
//  NXU_header(5)='use ieee.std_logic_unsigned.ALL'+ascii(59);

//--------------------VHDL data-->entity--------------------------------------------

  NXU_entity(1)='entity'+ascii(32)+fileName+ascii(32)+'is';

  NXU_entity(2)='port'+ascii(40);

//-----[top file-->entity ports define]

  NXU_entity_end='end'+ascii(32)+fileName+ascii(59);      

//----------------------VHDL data-->architecture------------------------------------

  arch_name='architecture NXU_beh of'+ascii(32)+fileName+ascii(32)+'is'; 

  NXU_archi_name=arch_name; 

//-----[top file-->signal_Blocks define]
//-----[top file-->signal_Embout define]
//-----[top file-->signal_Embin  define]

  NXU_begin='begin';

//-----[top file-->port map_Blocks data]

  NXU_archi_end='end'+ascii(32)+'NXU_beh'+ascii(59);

//----------------------VHDL data-->file.vhd------------------------------------------

//message('signal_B=='+signal_B)
//message('signal_O=='+signal_O)

  Copyright='';
  Copyright=mgetl('SCI/macros/scicos-hdl/vhdl/Copyrightvhdl.txt'); //symbol of victory

  vhdl_top=[NXU_header;NXU_entity;inData;outData;NXU_entity_end;NXU_archi_name;lmp;signal_B;signal_O;NXU_begin;mapbei_data;mapbl_data;mapbeo_data;NXU_archi_end;Copyright]

  VHDL_LANKC='';
  VHDL_LANKC=spitline(vhdl_top);
  
  
  kczd='ok';

//write(filePath+fileName+'.vhd',VHDL_LANKC)
  mdelete(filePath+fileName+'.vhd');

  mputl(VHDL_LANKC,filePath+fileName+'.vhd')
  
//------------------------------------

else
    //message("please put Input\Output block in");
   
    kczd='exit';
    return;
    
end  
  
  mclose('all');

endfunction



      


